C     Bolometric corrections (and in turn, color indices) using alpha_std 
C     models are computed for a sample of stars. The sample is read from the 
C     file "input.sample", where each row identifies a star of known 
C     logg, [Fe/H], Teff.
C 
C     Up to five filters can be chosen in selectbc.data (1 = ialf, for standard 
C     alpha variation).
C     After setting the desired parameters in selectbc.data, "getinputbcs" and 
C     "getbctable" must be compiled and run as usual (see README file). The 
C     desired value of E(B-V) must also be specified at this stage, and it 
C     will be used subsequently for all stars in "input.sample". 
C     bcstars.for can be compiled and linked as follows (e.g., ifort compiler):
C
C     ifort bcstars.for bcutil.for -o bcstars.exe
C
C     For each star the program returns BCs in the filters selected above 
C     (unit 6, i.e. on the monitor, from left to right, in the same order 
C     specified in selectbc.data, one star per row in the same order as 
C     "input.sample"). 
C     The user can then compute any color index (or combination of those) 
C     by simply doing the difference between the BCs in different bands.
C     NOTICE: since bolometric corrections -BCs- are returned, then a colour 
C     index i-j = BC_j - BC_i
C
C     If [alpha/Fe] of the input stars is also known, the interpolation using 
C     MARCS models with m04, p00 and p04 can also be done, instead of assuming 
C     standard alpha variation. In this case bcm04(5),bcp00(5),bcp04(5) must 
C     be uncommented below, and getbc_m04, getbc_p00.for, getbc_p04.for called. 
C     See colstar.for for an example of interpolation in [alpha/Fe].
C     In selectbc.data is also necessary to cycle through ialf, from 1 to 4. 

      real*4 a(3),x(3),bcstd(5)!,bcm04(5),bcp00(5),bcp04(5)
      character*6 fil(5)
      integer status

 1001 format(F4.2,X,F5.2,X,F6.0)
 1002 format(3x,'BC_1',4x,'BC_2',4x,'BC_3',4x,'BC_4',4x,'BC_5')
 1003 format(5(F7.3,X))

      write(6,1002) 

c *** read input file in loop till the end
      open(3,file='input.sample')
      readloop: do
      read(3,1001,IOSTAT=status) gv,fe,temp
      if (status /= 0) exit

      teff=alog10(temp)

c *** interpolate the bc_std tables to [Fe/H] 
      call getbc_std(0,fe,gv,teff,ebv,bcstd,fil,nbc)
c *** now perform the gv and Teff interpolation
      call getbc_std(1,fe,gv,teff,ebv,bcstd,fil,nbc)

      bc1 = bcstd(1)
      bc2 = bcstd(2)
      bc3 = bcstd(3)
      bc4 = bcstd(4)
      bc5 = bcstd(5)

c *** output is written on the monitor. User can send the output to a file 
c *** by simply modifying the code below
      write(6,1003) bc1,bc2,bc3,bc4,bc5

      end do readloop
      stop
      end

C *** This program compares the interpolated values of the bolometric
C *** corrections with those given in the files created by executing
C *** gettestbcs.for (which reproduce the BC values from the synthetic
C *** magnitudes as derived directly from the MARCS model atmosphere grids.
C
C *** Unit 33 contains the tabulated BCs that are interpolated: the name of
C *** the file is "bc_std.data", "bc_p04.data", "bc_p00.data", or
C *** "bc_m04.data", depending on whether the value of ialf in selectbc.data
C *** is 1, 2, 3, or 4, respectively.  Output is sent to unit 6, which is
C *** assumed to be attached to the monitor.
C 
C *** Very small adjustments are made to the input gv and Teff values
C *** to ensure that they stay within the set boundaries of gravity and
C *** temperature within which interpolations are performed.  Otherwise
C *** round-off or integer-to-real conversions causes input entries to
C *** be outside of those boundaries sometimes.
C
C *** the total number of interpolations (n) should equal the total
C *** number of data points in the input file minus number of entries
C *** for 2500 K, for [Fe/H] = -5.0, and for Teff values > the maximum
C *** value considered at a given value of log g.
C
      character*13 fnme
      fnme(1:13)='selectbc.data'
      call iofile(9,'in',fnme,13)
      read(9,*) ialf
      read(9,*) nfil
      if(ialf.gt.1) go to 5
      call intrp_s
      go to 10
    5 call intrp_a(ialf)
   10 stop
      end
      subroutine intrp_s
      real*4 g(13),bcin(5),bc(5),dif(5),bcx(5),dfx(5)
      integer*4 itm(13),num(13)
      character*13 fnme,fzero
      character*6 filter(41),gravity(13),fgrav,fil(5),fff(5),ff0
      character*5 ggg(5),gg1,gg0,ftype
      data g/-0.5,0.0,0.5,1.0,1.5,2.0,2.5,3.0,3.5,4.0,4.5,5.0,5.5/,
     1  itm/4250,5000,5500,6000,6500,6750,7750,8000,8000,8000,8000,
     2  8000,5000/,num/57,161,237,278,318,332,400,411,408,418,412,
     3  415,169/,gravity/'sphm05','sph00 ','sph05 ','sph10 ','sph15 ',
     4  'sph20 ','sph25 ','sph30 ','sph35 ','ppl40 ','ppl45 ','ppl50 ',
     5  'ppl55 '/,ftype/'.data'/,fzero/'             '/,gg1/'delta'/,
     6  filter/'  J   ','  H   ','  K   ','acs435','acs475','acs555',
     7  'acs606','acs814',' f218w',' f225w',' f275w',' f336w','f350lp',
     8  ' f390m',' f390w',' f438w',' f475w',' f547m',' f555w',' f606w',
     9  ' f625w',' f775w',' f814w','f850lp',' ir98m','ir110w','ir125w',
     *  'ir140w','ir160w','sdss_u','sdss_g','sdss_r','sdss_i','sdss_z',
     *  '  U   ','  B   ','  V   ','  R   ','  I   ','  UX  ','  BX  '/,
     *  ff0/'      '/,gg0/'     '/
 1000 format(i4,2f6.2,5f8.4)
 1001 format(' bc(i),bcin(i):',10f8.4)
 1002 format(/,8x,'input/',/,' log g',1x,'checked',2x,'Teff  [Fe/H]',
     1  5(2x,a6,3x,a5))
 1003 format(9x,f5.2)
 1004 format(i3)
 1005 format(f5.1,2x,i3,'/',i3,2x,i4,f7.2,1x,10f8.4)
c *** read the input bolometric correction tables (= bc_std.data)
      fe=0.0
      call getbc_s(0,fe,gv,teff,ebv,bc,fil,nbc)
      do 5 i=1,nbc
      fff(i)=ff0
      ggg(i)=gg0
    5 continue
      do 8 i=1,nbc
      read(9,*) isys,ifil
      fff(i)=filter(ifil)
      ggg(i)=gg1
    8 continue
      nf1=9
      write(6,1002) (fff(i),ggg(i),i=1,nbc)
      do 45 j=1,13
      nf1=nf1+1
      fnme=fzero
      fgrav=gravity(j)
      fnme(1:6)=fgrav(1:6)
      nch=6
      if(j.eq.1) go to 10
      nch=5
   10 fnme(nch+1:nch+5)=ftype(1:5)
      nch=nch+5
      call iofile(nf1,'in',fnme,nch)
      gv=g(j)
      itx=itm(j)
      n=0
      dmax=0.0
      read(nf1,1003) redden
      read(nf1,1004) npt
      do 40 m=1,npt
      read(nf1,1000) ite,fe,afe,(bcin(k),k=1,nbc)
      temp=float(ite)
      teff=alog10(temp)
      if(fe.lt.-4.0) go to 40
      if(ite.lt.2600.or.ite.gt.itx) go to 40
      call getbc_s(-1,fe,gv,teff,ebv,bc,fil,nbc)
      call getbc_s(1,fe,gv,teff,ebv,bc,fil,nbc)
      difmax=0.0
      do 25 l=1,nbc
      dif(l)=abs(bc(l)-bcin(l))
      difmax=amax1(dif(l),difmax)
      if(difmax.lt.dmax) go to 20
      dmax=difmax
      itmx=ite
      femx=fe
      afex=afe
      do 15 k=1,nbc
      dfx(k)=dif(k)
      bcx(k)=bc(k)
   15 continue
   20 if(abs(bc(l)-bcin(l)).gt.0.001) go to 30
   25 continue
      go to 35
   30 write(6,1001) (bc(k),bcin(k),k=1,nbc)
      go to 40
   35 n=n+1
   40 continue
      write(6,1005) g(j),num(j),n,itmx,femx,(bcx(k),dfx(k),k=1,nbc)
   45 continue
      stop
      end
      subroutine intrp_a(ialf)
      real*4 g(12),bcin(5),bc(5),dif(5),bcx(5),dfx(5)
      integer*4 itm(12),num(12),nump04(12),nump00(12),numm04(12)
      character*13 fnme,fzero
      character*6 filter(41),fil(5),fff(5),ff0
      character*5 gravity(12),ggg(5),gg1,gg0,fgrav,ftype
      data g/0.0,0.5,1.0,1.5,2.0,2.5,3.0,3.5,4.0,4.5,5.0,5.5/,
     1  itm/5000,5250,5500,5750,6250,7750,8000,8000,8000,8000,8000,
     2  5000/,nump04/80,108,122,132,139,173,179,175,170,171,178,80/,
     3  nump00/87,136,146,151,158,192,210,207,211,210,212,88/,
     4  numm04/133,177,186,193,202,240,251,245,256,258,255,134/,
     5  gravity/'sph00','sph05','sph10','sph15','sph20','sph25',
     6  'sph30','sph35','ppl40','ppl45','ppl50','ppl55'/,gg1/'delta'/,
     7  ftype/'.data'/,fzero/'             '/,filter/'  J   ','  H   ',
     8  '  K   ','acs435','acs475','acs555','acs606','acs814',' f218w',
     9  ' f225w',' f275w',' f336w','f350lp',' f390m',' f390w',' f438w',
     *  ' f475w',' f547m',' f555w',' f606w',' f625w',' f775w',' f814w',
     *  'f850lp',' ir98m','ir110w','ir125w','ir140w','ir160w','sdss_u',
     *  'sdss_g','sdss_r','sdss_i','sdss_z','  U   ','  B   ','  V   ',
     *  '  R   ','  I   ','  UX  ','  BX  '/,ff0/'      '/,gg0/'     '/
 1000 format(i4,2f6.2,5f8.4)
 1001 format(' bc(i),bcin(i):',10f8.4)
 1002 format(/,8x,'input/',/,' log g',1x,'checked',2x,'Teff  [Fe/H]',
     1  5(2x,a6,3x,a5))
 1003 format(9x,f5.2)
 1004 format(i3)
 1005 format(f5.1,2x,i3,'/',i3,2x,i4,f7.2,1x,10f8.4)
      if(ialf.gt.2) go to 10
      do 5 i=1,12
      num(i)=nump04(i)
    5 continue
      go to 30
   10 if(ialf.gt.3) go to 20
      do 15 i=1,12
      num(i)=nump00(i)
   15 continue
      go to 30
   20 do 25 i=1,12
      num(i)=numm04(i)
   25 continue
c *** read the input bolometric correction tables (e.g., bc_p04.data)
   30 fe=0.0
      call getbc_a(0,ialf,fe,gv,teff,ebv,bc,fil,nbc)
      do 35 i=1,nbc
      fff(i)=ff0
      ggg(i)=gg0
   35 continue
      do 40 i=1,nbc
      read(9,*) isys,ifil
      fff(i)=filter(ifil)
      ggg(i)=gg1
   40 continue
      nf1=9
      write(6,1002) (fff(i),ggg(i),i=1,nbc)
      do 75 j=1,12
      nf1=nf1+1
      fnme=fzero
      fgrav=gravity(j)
      fnme(1:5)=fgrav(1:5)
      fnme(6:10)=ftype(1:5)
      nch=10
      call iofile(nf1,'in',fnme,nch)
      gv=g(j)
      itx=itm(j)
      n=0
      dmax=0.0
      read(nf1,1003) redden
      read(nf1,1004) npt
      do 70 m=1,npt
      read(nf1,1000) ite,fe,afe,(bcin(k),k=1,nbc)
      temp=float(ite)
      teff=alog10(temp)
      if(fe.lt.-2.5.or.fe.gt.0.5) go to 70
      if(ite.lt.2600.or.ite.gt.itx) go to 70
      call getbc_a(-1,ialf,fe,gv,teff,ebv,bc,fil,nbc)
      call getbc_a(1,ialf,fe,gv,teff,ebv,bc,fil,nbc)
      difmax=0.0
      do 55 l=1,nbc
      dif(l)=abs(bc(l)-bcin(l))
      difmax=amax1(dif(l),difmax)
      if(difmax.lt.dmax) go to 50
      dmax=difmax
      itmx=ite
      femx=fe
      afex=afe
      do 45 k=1,nbc
      dfx(k)=dif(k)
      bcx(k)=bc(k)
   45 continue
   50 if(abs(bc(l)-bcin(l)).gt.0.001) go to 60
   55 continue
      go to 65
   60 write(6,1001) (bc(k),bcin(k),k=1,nbc)
      go to 70
   65 n=n+1
   70 continue
      write(6,1005) g(j),num(j),n,itmx,femx,(bcx(k),dfx(k),k=1,nbc)
   75 continue
      stop
      end
      Subroutine getbc_s(mode,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 3 filter bandpasses
C     of choice.  The standard variation of [alpha/Fe] with [Fe/H] is
C     assumed; i.e., [alpha/Fe] = +0.4 at [Fe/H] <= -1.0, 0.0 at [Fe/H]
C     >= 0.0, and [alpha/Fe] = -0.4[Fe/H] at intermediate iron abundances.
C     The input tables, in a file named `bc_std.data', are assigned to
C     unit 30.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if (i) the input [Fe/H]
C     value is outside the range of the input tables, (ii) the input log g
C     or log Teff values are outside the tabulated ranges, or (ii) the
C     input file (`bc_std.data') does not exist.
C -------------------------------------------------------------------7--
      real*4 ttt(8),bc(5)
      character*29 alfe(15)
      character*10 namfe
      character*6 fil(5)
      common /bcstd/ a(31,13,5,15),b(31,13,5),c(4,5),te(31),t(31),g(13),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(13),nt,ng,nfe,ndx
      data ttt/4250.,5000.,5500.,6000.,6500.,6750.,7750.,8000./
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] =',f6.2,
     1  /,' filters: ',5(a6,2x))
 1005 format(' log g =',f9.6,'  or Teff =',f9.3,' are outside the',
     1  1x,'range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' input  fe =',f5.2,' is outside the range of table',i2)
 1008 format(20i4)
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      open(unit=33,iostat=ierr,file='bc_std.data',status='old')
      if(ierr.ne.0) go to 150
      read(33,1000) nt,ng,nfe,ndx,ebv
      read(33,1001) (te(i),i=1,nt)
      read(33,1002) (g(i),i=1,ng)
      read(33,1008) (maxt(i),i=1,ng)
      nbc=ndx
      do 5 i=1,8
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(33,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=1,ng
      nend=maxt(j)
      read(33,1003) (a(i,j,k,l),i=1,nend)
   15 continue
   20 continue
      close(unit=33,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      nend=maxt(j)
      do 45 i=1,nend
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 155
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 155
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) gv,temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.-0.5.or.gv.gt.5.5) go to 65
C *** Note that ngmin=1 only if the input value of gv is < 0.0.
      ngmin=2
      if(gv.ge.0.0) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,8
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=13 only if the input value of gv is > 5.0.
      ngmax=13
      if(gv.gt.5.0) go to 90
      ngmax=12
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 155
  150 stop ' input file bc_std.data does not exist'
  155 return
      end
      subroutine iofile(nunit,fstat,fnme,nch)
      integer*4 nunit,nch
      character*13 fnme
      character*2 fstat
 1000 format(' unit',i3,' input file does not exist',/,'name = ',a52)
      if(fstat.eq.'in') go to 10
c *** the named file is apparently an output file
      open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='new')
      if(ierr.eq.0) go to 15
c *** if the named file already exists it is deleted and opened as a
c *** new file; i.e., the existing file will be overwritten
      open(unit=nunit,file=fnme(1:nch),status='old')
      close(unit=nunit,status='delete')
      open(unit=nunit,file=fnme(1:nch),status='new')
      go to 15
c *** the named file is an input file 
   10 open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='old')
      if(ierr.eq.0) go to 15
c *** the named input file apparently does not exist: execution terminated
      write(6,1000) nunit,fnme
      stop ' specified input file does not exist'
   15 return
      end
      Subroutine getbc_a(mode,ialf,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 3 filter bandpasses
C     of choice.  The input tables, in a file named `bc_p04.data' which is
C     assigned to unit 33, assume that [alpha/Fe] = +0.4 for all [Fe/H]
C     values.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.  
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if (i) the input [Fe/H]
C     value is outside the range of the input tables, (ii) the input log g
C     or log Teff values are outside the tabulated ranges, or (ii) the
C     input file (`bc_p04.data') does not exist.
C -------------------------------------------------------------------7--
      real*4 ttt(7),bc(5)
      character*29 alfe(15)
      character*11 filen(4),fnme
      character*10 namfe
      character*6 fil(5)
      common /bcp04/ a(31,12,5,15),b(31,12,5),c(4,5),te(31),t(31),g(12),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(12),nt,ng,nfe,ndx
      data ttt/5000.,5250.,5500.,5750.,6250.,7750.,8000./,
     1  filen/'bc_std.data','bc_p04.data','bc_p00.data','bc_m04.data'/
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] =',f6.2,
     1  /,' filters: ',5(a6,2x))
 1005 format(' log g =',f9.6,'  or Teff =',f9.3,' are outside the',
     1  1x,'range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' input  fe =',f5.2,' is outside the range of table',i2)
 1008 format(20i4)
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      fnme=filen(ialf)
      open(unit=33,iostat=ierr,file=fnme,status='old')
      if(ierr.ne.0) go to 150
      read(33,1000) nt,ng,nfe,ndx,ebv
      read(33,1001) (te(i),i=1,nt)
      read(33,1002) (g(i),i=1,ng)
      read(33,1008) (maxt(i),i=1,ng)
      nbc=ndx
      do 5 i=1,7
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(33,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=1,ng
      nend=maxt(j)
      read(33,1003) (a(i,j,k,l),i=1,nend)
   15 continue
   20 continue
      close(unit=33,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      nend=maxt(j)
      do 45 i=1,nend
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 155
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 155
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) gv,temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.0.0.or.gv.gt.5.5) go to 65
C *** Note that ngmin=1 only if the input value of gv is < 0.5.
      ngmin=2
      if(gv.ge.0.5) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,7
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=12 only if the input value of gv is > 5.0.
      ngmax=12
      if(gv.gt.5.0) go to 90
      ngmax=11
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 155
  150 stop ' input file bc_p04.data does not exist'
  155 return
      end
      subroutine lgr4(x,a,xx)
C *** a 4-point Lagrangian interpolation subroutine
      real*4 x(4),a(4)
      r1=(x(1)-x(2))*(x(1)-x(3))*(x(1)-x(4))
      r2=(x(2)-x(1))*(x(2)-x(3))*(x(2)-x(4))
      r3=(x(3)-x(1))*(x(3)-x(2))*(x(3)-x(4))
      r4=(x(4)-x(1))*(x(4)-x(2))*(x(4)-x(3))
      a(1)=((xx-x(2))*(xx-x(3))*(xx-x(4)))/r1
      a(2)=((xx-x(1))*(xx-x(3))*(xx-x(4)))/r2
      a(3)=((xx-x(1))*(xx-x(2))*(xx-x(4)))/r3
      a(4)=((xx-x(1))*(xx-x(2))*(xx-x(3)))/r4
      return
      end

      Subroutine getbc_std(mode,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** Note that bc and fil are arrays: the program which calls getbc_std
C     must have the specifications "real*4 bc(5)" and "character*6 fil(5)"
C     in it to avoid errors.
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 5 filter bandpasses
C     of choice.  The standard variation of [alpha/Fe] with [Fe/H] is
C     assumed; i.e., [alpha/Fe] = +0.4 at [Fe/H] <= -1.0, 0.0 at [Fe/H]
C     >= 0.0, and [alpha/Fe] = -0.4[Fe/H] at intermediate iron abundances.
C     The input tables, in a file named `bc_std.data', are assigned to
C     unit 30.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if the input [Fe/H]
C     or log Teff values are outside the ranges assumed in "bc_std.data"
C     or the latter file does not exist.  If the input value of log g is
C     outside the tabulated range, the output BC values are all set to a
C     value of "9.9999".
C -------------------------------------------------------------------7--
      real*4 ttt(8),bc(5)
      character*29 alfe(15)
      character*10 namfe
      character*6 fil(5)
      common /bcstd/ a(31,13,5,15),b(31,13,5),c(4,5),te(31),t(31),g(13),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(13),nt,ng,nfe,ndx
      data ttt/4250.,5000.,5500.,6000.,6500.,6750.,7750.,8000./
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' bc_std BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] ='
     1  ,f6.2,/,16x,'filters: ',5(a6,2x))
 1005 format(' Teff =',f8.2,' is outside the range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' fe =',f5.2,' is outside the range of the input tables')
 1008 format(20i4)
 1009 format(' log g =',f7.4,' is outside the range of the input',1x,
     1  'tables: no interpolations are performed - bc(i) = 9.9999')
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      open(unit=30,iostat=ierr,file='bc_std.data',status='old')
      if(ierr.ne.0) go to 150
      read(30,1000) nt,ng,nfe,ndx,ebv
      read(30,1001) (te(i),i=1,nt)
      read(30,1002) (g(i),i=1,ng)
      read(30,1008) (maxt(i),i=1,ng)
      nbc=ndx
      do 5 i=1,8
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(30,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=1,ng
      ntot=maxt(j)
      read(30,1003) (a(i,j,k,l),i=1,ntot)
   15 continue
   20 continue
      close(unit=30,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      ntot=maxt(j)
      do 45 i=1,ntot
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 165
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 165
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.-0.5.or.gv.gt.5.5) go to 155
C *** Note that ngmin=1 only if the input value of gv is < 0.0.
      ngmin=2
      if(gv.ge.0.0) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,8
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=13 only if the input value of gv is > 5.0.
      ngmax=13
      if(gv.gt.5.0) go to 90
      ngmax=12
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 165
  150 stop ' input file bc_std.data does not exist'
  155 do 160 i=1,ndx
      bc(i)=9.9999
  160 continue
      write(6,1009) gv
  165 return
      end
      Subroutine getbc_p04(mode,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** Note that bc and fil are arrays: the program which calls getbc_p04
C     must have the specifications "real*4 bc(5)" and "character*6 fil(5)"
C     in it to avoid errors.
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 5 filter bandpasses
C     of choice.  The input tables, in a file named `bc_p04.data' which is
C     assigned to unit 30, assume that [alpha/Fe] = +0.4 for all [Fe/H]
C     values.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.  
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if the input [Fe/H]
C     or log Teff values are outside the ranges assumed in "bc_p04.data"
C     or the latter file does not exist.  If the input value of log g is
C     outside the tabulated range, the output BC values are all set to a
C     value of "9.9999".
C -------------------------------------------------------------------7--
      real*4 ttt(8),bc(5)
      character*29 alfe(15)
      character*10 namfe
      character*6 fil(5)
      common /bcp04/ a(31,13,5,15),b(31,13,5),c(4,5),te(31),t(31),g(13),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(13),nt,ng,nfe,ndx
      data ttt/4250.,5000.,5250.,5500.,5750.,6250.,7750.,8000./
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' bc_p04 BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] ='
     1  ,f6.2,/,16x,'filters: ',5(a6,2x))
 1005 format(' Teff =',f8.2,' is outside the range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' fe =',f5.2,' is outside the range of the input tables')
 1008 format(20i4)
 1009 format(' log g =',f7.4,' is outside the range of the input',1x,
     1  'tables: no interpolations are performed - bc(i) = 9.9999')
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      open(unit=30,iostat=ierr,file='bc_p04.data',status='old')
      if(ierr.ne.0) go to 150
      read(30,1000) nt,ng,nfe,ndx,ebv
      ng=13
      read(30,1001) (te(i),i=1,nt)
      read(30,1002) (g(i),i=2,ng)
      read(30,1008) (maxt(i),i=2,ng)
      nbc=ndx
      do 5 i=1,8
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(30,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=2,ng
      ntot=maxt(j)
      read(30,1003) (a(i,j,k,l),i=1,ntot)
   15 continue
   20 continue
C *** linear extrapolation of tables to log g = -0.5 (Teff from 2600 to 4250 K)
      g(1)=-0.5
      maxt(1)=16
      do 22 i=1,16
      a(i,1,k,l)=2.*(a(i,2,k,l)-a(i,3,k,l))
   22 continue
      close(unit=30,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      ntot=maxt(j)
      do 45 i=1,ntot
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 165
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 165
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.-0.5.or.gv.gt.5.5) go to 155
C *** Note that ngmin=1 only if the input value of gv is < 0.0, and
C *** that ngmin=2 only if gv < 0.5 but >= 0.0
      ngmin=3
      if(gv.ge.0.5) go to 75
      ngmin=2
      if(gv.ge.0.0) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,8
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=13 only if the input value of gv is > 5.0.
      ngmax=13
      if(gv.gt.5.0) go to 90
      ngmax=12
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 165
  150 stop ' input file bc_p04.data does not exist'
  155 do 160 i=1,ndx
      bc(i)=9.9999
  160 continue
      write(6,1009) gv
  165 return
      end
      Subroutine getbc_p00(mode,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** Note that bc and fil are arrays: the program which calls getbc_p00
C     must have the specifications "real*4 bc(5)" and "character*6 fil(5)"
C     in it to avoid errors.
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 5 filter bandpasses
C     of choice.  The input tables, in a file named `bc_p00.data' which is
C     assigned to unit 30, assume that [alpha/Fe] = 0.0 for all [Fe/H]
C     values.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.  
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if the input [Fe/H]
C     or log Teff values are outside the ranges assumed in "bc_p00.data"
C     or the latter file does not exist.  If the input value of log g is
C     outside the tabulated range, the output BC values are all set to a
C     value of "9.9999".
C -------------------------------------------------------------------7--
      real*4 ttt(8),bc(5)
      character*29 alfe(15)
      character*10 namfe
      character*6 fil(5)
      common /bcp00/ a(31,13,5,15),b(31,13,5),c(4,5),te(31),t(31),g(13),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(13),nt,ng,nfe,ndx
      data ttt/4250.,5000.,5250.,5500.,5750.,6250.,7750.,8000./
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' bc_p00 BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] ='
     1  ,f6.2,/,16x,'filters: ',5(a6,2x))
 1005 format(' Teff =',f8.2,' is outside the range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' fe =',f5.2,' is outside the range of the input tables')
 1008 format(20i4)
 1009 format(' log g =',f7.4,' is outside the range of the input',1x,
     1  'tables: no interpolations are performed - bc(i) = 9.9999')
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      open(unit=30,iostat=ierr,file='bc_p00.data',status='old')
      if(ierr.ne.0) go to 150
      read(30,1000) nt,ng,nfe,ndx,ebv
      ng=13
      read(30,1001) (te(i),i=1,nt)
      read(30,1002) (g(i),i=2,ng)
      read(30,1008) (maxt(i),i=2,ng)
      nbc=ndx
      do 5 i=1,8
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(30,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=2,ng
      ntot=maxt(j)
      read(30,1003) (a(i,j,k,l),i=1,ntot)
   15 continue
   20 continue
C *** linear extrapolation of tables to log g = -0.5 (Teff from 2600 to 4250 K)
      g(1)=-0.5
      maxt(1)=16
      do 22 i=1,16
      a(i,1,k,l)=2.*(a(i,2,k,l)-a(i,3,k,l))
   22 continue
      close(unit=30,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      ntot=maxt(j)
      do 45 i=1,ntot
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 165
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 165
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.-0.5.or.gv.gt.5.5) go to 155
C *** Note that ngmin=1 only if the input value of gv is < 0.0, and
C *** that ngmin=2 only if gv < 0.5 but >= 0.0
      ngmin=3
      if(gv.ge.0.5) go to 75
      ngmin=2
      if(gv.ge.0.0) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,8
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=13 only if the input value of gv is > 5.0.
      ngmax=13
      if(gv.gt.5.0) go to 90
      ngmax=12
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 165
  150 stop ' input file bc_p00.data does not exist'
  155 do 160 i=1,ndx
      bc(i)=9.9999
  160 continue
      write(6,1009) gv
  165 return
      end
      Subroutine getbc_m04(mode,fe,gv,teff,ebv,bc,fil,nbc)
C ----------------------------------------------------------------------
C *** Note that bc and fil are arrays: the program which calls getbc_m04
C     must have the specifications "real*4 bc(5)" and "character*6 fil(5)"
C     in it to avoid errors.
C *** This routine interpolates in the tables of bolometric corrections
C     derived from MARCS model atmospheres for up to 5 filter bandpasses
C     of choice.  The input tables, in a file named `bc_m04.data' which is
C     assigned to unit 30, assume that [alpha/Fe] = -0.4 for all [Fe/H]
C     values.
C
C *** If MODE=0, the BC tables are read and interpolated to the desired
C     value of [Fe/H] (= fe in the argument list).  MODE must be set to
C     zero the first time that this subroutine is called.  A message is
C     sent to unit 6 (which is assumed to be attached to the monitor) to
C     specify the [Fe/H] value and the magnitudes (e.g., B, I, F606W) for
C     which bolometric corrections are provided in the input tables.  
C
C *** If MODE=1, interpolations are carried out to obtain the bolometric
C     corrections at the input values of log g and log Te (gv and teff in
C     the argument list) and the specified [Fe/H] value.  It is only for
C     this value of MODE that interpolations are performed to obtain BC
C     information.
C
C *** If MODE=-1, the input tables (which were previously read by setting
C     MODE=0) are re-interpolated for a new value of [Fe/H].  If desired,
C     the subroutine may be modified (after the statement `45 continue')
C     so that a message is sent to unit 6 each time an [Fe/H] interpolation
C     is performed.
C
C *** The interpolation code will issue a STOP code if the input [Fe/H]
C     or log Teff values are outside the ranges assumed in "bc_m04.data"
C     or the latter file does not exist.  If the input value of log g is
C     outside the tabulated range, the output BC values are all set to a
C     value of "9.9999".
C -------------------------------------------------------------------7--
      real*4 ttt(8),bc(5)
      character*29 alfe(15)
      character*10 namfe
      character*6 fil(5)
      common /bcm04/ a(31,13,5,15),b(31,13,5),c(4,5),te(31),t(31),g(13),
     1  feh(15),ttm(8),r(4),af(4),ag(4),at(4),maxt(13),nt,ng,nfe,ndx
      data ttt/4250.,5000.,5250.,5500.,5750.,6250.,7750.,8000./
 1000 format(/,i3,14x,i2,14x,i2,14x,i2,21x,f6.3)
 1001 format(13f6.0)
 1002 format(20f4.1)
 1003 format(10f8.4)
 1004 format(' bc_m04 BCs for E(B-V) =',f6.3,' interpolated to [Fe/H] ='
     1  ,f6.2,/,16x,'filters: ',5(a6,2x))
 1005 format(' Teff =',f8.2,' is outside the range of the input tables')
 1006 format(a10,f5.2,a29,a6)
 1007 format(' fe =',f5.2,' is outside the range of the input tables')
 1008 format(20i4)
 1009 format(' log g =',f7.4,' is outside the range of the input',1x,
     1  'tables: no interpolations are performed - bc(i) = 9.9999')
      if(mode.gt.0) go to 50
      if(mode.lt.0) go to 25
C *** The input BC tables are read only if MODE=0.
      open(unit=30,iostat=ierr,file='bc_m04.data',status='old')
      if(ierr.ne.0) go to 150
      read(30,1000) nt,ng,nfe,ndx,ebv
      ng=13
      read(30,1001) (te(i),i=1,nt)
      read(30,1002) (g(i),i=2,ng)
      read(30,1008) (maxt(i),i=2,ng)
      nbc=ndx
      do 5 i=1,8
      ttm(i)=alog10(ttt(i))
    5 continue
      do 10 i=1,nt
      t(i)=alog10(te(i))
   10 continue
      do 20 k=1,ndx
      do 20 l=1,nfe
      read(30,1006) namfe,feh(l),alfe(l),fil(k)
      do 15 j=2,ng
      ntot=maxt(j)
      read(30,1003) (a(i,j,k,l),i=1,ntot)
   15 continue
   20 continue
C *** linear extrapolation of tables to log g = -0.5 (Teff from 2600 to 4250 K)
      g(1)=-0.5
      maxt(1)=16
      do 22 i=1,16
      a(i,1,k,l)=2.*(a(i,2,k,l)-a(i,3,k,l))
   22 continue
      close(unit=30,status='keep')
C *** When MODE=0 OR MODE=-1, the input BC table is interpolated to
C *** create a table of BC values for the input value of [Fe/H) (=fe).
   25 if(fe.lt.feh(1).or.fe.gt.feh(nfe)) go to 35
      nfem1=nfe-1
      do 30 m=3,nfem1
      l=m-2
      if(fe.le.feh(m)) go to 40
   30 continue
      go to 40
   35 write(6,1007) fe
      stop ' input [Fe/H] value is outside the range of the tables'
   40 r(1)=feh(l)
      r(2)=feh(l+1)
      r(3)=feh(l+2)
      r(4)=feh(l+3)
      call lgr4(r,af,fe)
      do 45 k=1,ndx
      do 45 j=1,ng
      ntot=maxt(j)
      do 45 i=1,ntot
      b(i,j,k)=af(1)*a(i,j,k,l)+af(2)*a(i,j,k,l+1)+af(3)*a(i,j,k,l+2)+
     1  af(4)*a(i,j,k,l+3)
   45 continue
C *** If desired, the following statement may be commented out so that
C *** the write statement is executed after each [Fe/H] interpolation.
      if(mode.ne.0) go to 165
      write(6,1004) ebv,fe,(fil(k),k=1,ndx)
C *** When MODE=0 or MODE=-1, control returns to the calling program
C *** once the [Fe/H] interpolations have been completed; i.e., no
C *** interpolations are performed within the tables.
      go to 165
C *** MODE=1: interpolations are performed for the input values of
C *** log g (= gv) and log Teff (= teff).
   50 nbc=ndx
      temp=10.**teff
      if(abs(teff-t(nt)).ge.1.e-5) go to 55
      teff=t(nt)
   55 if(abs(teff-t(1)).ge.1.e-5) go to 60 
      teff=t(1)
   60 if(teff.le.t(nt).and.teff.ge.t(1)) go to 70
   65 write(6,1005) temp
      stop ' range of the tables exceeded'
   70 if(gv.lt.-0.5.or.gv.gt.5.5) go to 155
C *** Note that ngmin=1 only if the input value of gv is < 0.0, and
C *** that ngmin=2 only if gv < 0.5 but >= 0.0
      ngmin=3
      if(gv.ge.0.5) go to 75
      ngmin=2
      if(gv.ge.0.0) go to 75
      ngmin=1
C *** This loop determines the index ngm where ng(ngm) is the lowest
C *** value of log g for which data are available for the input Teff.
   75 do 80 i=ngmin,8
      ngm=i
      if(teff.le.ttm(i)) go to 85
   80 continue
   85 ngl=ngm+2
C *** Note that ngmax=13 only if the input value of gv is > 5.0.
      ngmax=13
      if(gv.gt.5.0) go to 90
      ngmax=12
   90 ngm=ngmax-1
C *** This loop determines the index mg where g(mg) is the lowest 
C *** of the grid values of log g that are used in the interpolations.
      do 95 i=ngl,ngm
      mg=i-2
      if(gv.le.g(i)) go to 105
   95 continue
      mg=ngmax-3
  105 mmx=maxt(mg)
C *** This section increases the value of mg if the maximum value of
C *** Teff at the initial value of mg is less than the input Teff.
      if(teff.le.t(mmx)) go to 110
      mg=mg+1
      mmx=maxt(mg)
C *** This section tests whether the maximum value of Teff at the
C *** revised value of mg is >= the input Teff value.  If this condition
C *** is not satisfied, the execution terminates.
      if(teff.gt.t(mmx)) go to 65
  110 r(1)=g(mg)
      r(2)=g(mg+1)
      r(3)=g(mg+2)
      r(4)=g(mg+3)
C *** The Lagrangian coefficients for the log g interpolation are computed.
      call lgr4(r,ag,gv)
      ntm=nt-1
C *** This loop determines the value of mt where t(mt) is the lowest of
C *** the grid values of log Teff that are used in the interpolations.
      do 115 i=3,ntm
      mt=i-2
      if(teff.le.t(i)) go to 120
  115 continue
      mt=nt-3
C *** This section checks that the input T is <= the maximum value for
C *** which tabulated data are available at the lowest value of mg 
C *** in the interpolations.
  120 limt=maxt(mg)
      if(gv.le.5.0) go to 125
      limt=19
      if(teff.gt.t(limt)) go to 65
  125 if((mt+3).le.limt) go to 130
      mt=limt-3
  130 r(1)=t(mt)
      r(2)=t(mt+1)
      r(3)=t(mt+2)
      r(4)=t(mt+3)
C *** The Lagrangian coefficients for the log Teff interpolations are computed.
      call lgr4(r,at,teff)
      l=mg-1
C *** The desired bolometric corrections are calculated.
      do 140 i=1,4
      l=l+1
      do 135 k=1,ndx
      c(i,k)=at(1)*b(mt,l,k)+at(2)*b(mt+1,l,k)+at(3)*b(mt+2,l,k)+
     1   at(4)*b(mt+3,l,k)
  135 continue
  140 continue
      do 145 i=1,ndx
      bc(i)=ag(1)*c(1,i)+ag(2)*c(2,i)+ag(3)*c(3,i)+ag(4)*c(4,i)
  145 continue
      go to 165
  150 stop ' input file bc_m04.data does not exist'
  155 do 160 i=1,ndx
      bc(i)=9.9999
  160 continue
      write(6,1009) gv
  165 return
      end
      subroutine lgran3(x,a,xx)
C *** a 3-point Lagrange interpolation subroutine
C *** x(i) = abscissae values
C *** a(i) = Lagrange coefficients
C *** xx = value of x-coordinate at which an interpolation is to be made
C ***      in the calling program via yy=a(1)*y(1)+a(2)*y(2)+a(3)*y(3)
      real*4 x(3),a(3)
      r1=(x(1)-x(2))*(x(1)-x(3))
      r2=(x(2)-x(1))*(x(2)-x(3))
      r3=(x(3)-x(1))*(x(3)-x(2))
      a(1)=((xx-x(2))*(xx-x(3)))/r1
      a(2)=((xx-x(1))*(xx-x(3)))/r2
      a(3)=((xx-x(1))*(xx-x(2)))/r3
      return
      end
      subroutine lgr4(x,a,xx)
C *** a 4-point Lagrange interpolation subroutine (similar to lgran3)
      real*4 x(4),a(4)
      r1=(x(1)-x(2))*(x(1)-x(3))*(x(1)-x(4))
      r2=(x(2)-x(1))*(x(2)-x(3))*(x(2)-x(4))
      r3=(x(3)-x(1))*(x(3)-x(2))*(x(3)-x(4))
      r4=(x(4)-x(1))*(x(4)-x(2))*(x(4)-x(3))
      a(1)=((xx-x(2))*(xx-x(3))*(xx-x(4)))/r1
      a(2)=((xx-x(1))*(xx-x(3))*(xx-x(4)))/r2
      a(3)=((xx-x(1))*(xx-x(2))*(xx-x(4)))/r3
      a(4)=((xx-x(1))*(xx-x(2))*(xx-x(3)))/r4
      return
      end

C *** This program fits Akima splines to the BC tables for E(B-V) = 0.00,
C *** 0.12, 0.24, 0.36, 0.48, 0.60, and 0.72 and and uses these splines to
C *** produce a BC table (with the name "bc_std.data", "bc_p04.data",
C *** "bc_p00.data", or "bc_m04.data" if ialf = 1, 2, 3, or 4, respectively)
C *** for any desired (input) value of E(B-V) within the above range.  Note
C *** that the output file ("bc_***.data") is rewritten each time this
C *** program is executed.
C
      real*8 c(4,7),x(7),y(7),red,xin,yout,deriv
      real*4 b(7,40),ys(40),teff(31),fet(15),aft(15),gv(13)
      character*42 fnme
      character*21 namred
      character*11 fout(4),fiout,namsys
      character*6 name
      integer*4 itmm(13)
      data fout/'bc_std.data','bc_p04.data','bc_p00.data','bc_m04.data'/
 1000 format(' enter E(B-V) value for which BCs are to be generated')
 1002 format(15i4) 
 1003 format(' Tables of Bolometric Corrections Derived from the',
     1  1x,'2008 MARCS model atmospheres',/,i3,' Teffs',8x,i2,
     2  ' log gs',7x,i2,' [Fe/H]s',6x,i2,a21,f6.3)
 1004 format(13f6.0)
 1005 format(15f4.1)
 1006 format(' [Fe/H] = ',f5.2,' [alpha/Fe] =',f5.2,' BC value =',a6,
     1  a11)
 1007 format(10f8.4)
 1008 format(i3,14x,i2,14x,i2,14x,i2,a21)
 1009 format(10x,f5.2,13x,f5.2,11x,a6,a11)
 1010 format(/,1x,a11,' has been created assuming E(B-V) =',f6.3)
c *** read the input reddening (= xx) and define the independent x(i) values
      fnme(1:13)='selectbc.data'
      call iofile(9,'in',fnme,13)
      read(9,*) ialf
      fiout=fout(ialf)
      write(6,1000)
      read(5,*) xx
      xin=dble(xx)
      red=-0.12d0
      do 5 i=1,7
      red=red+0.12d0
      x(i)=red
    5 continue
c *** assign the files to be interpolated
c     open(unit=10,err=45,file='bctable.data',status='new')
      open(unit=10,iostat=ierr,file=fiout,status='new')
      if(ierr.eq.0) go to 10
      open(unit=10,file=fiout,status='old')
      close(unit=10,status='delete')
      open(unit=10,file=fiout,status='new')
   10 open(unit=30,err=60,file='inputbc_r00.data',status='old')
      open(unit=31,err=60,file='inputbc_r12.data',status='old')
      open(unit=32,err=60,file='inputbc_r24.data',status='old')
      open(unit=33,err=60,file='inputbc_r36.data',status='old')
      open(unit=34,err=60,file='inputbc_r48.data',status='old')
      open(unit=35,err=60,file='inputbc_r60.data',status='old')
      open(unit=36,err=60,file='inputbc_r72.data',status='old')
c *** n is the number of input BC files (normally 7)
      n=7
c *** read the header lines from the 7 input files
      nf1=29
      do 15 i=1,7
      nf1=nf1+1
      read(nf1,1008) nt,ng,nfe,nbc,namred
      read(nf1,1004) (teff(j),j=1,nt)
      read(nf1,1005) (gv(j),j=1,ng)
      read(nf1,1002) (itmm(j),j=1,ng)
   15 continue
c *** write the header lines for the output file
      write(10,1003) nt,ng,nfe,nbc,namred,xx
      write(10,1004) (teff(j),j=1,nt)
      write(10,1005) (gv(j),j=1,ng)
      write(10,1002) (itmm(j),j=1,ng)
c *** main do-loops for the spline interpolations
      do 50 ll=1,nbc
      do 45 kk=1,nfe
c *** read the header line for each of the 7 input BC tables
      nf1=29
      do 20 i=1,7
      nf1=nf1+1
      read(nf1,1009) feh,afe,name,namsys
   20 continue
c *** write the corresponding header line for the output file
      write(10,1006) feh,afe,name,namsys
c *** read the BC data for all Teff values at a given gravity
      do 40 jj=1,ng
      itm=itmm(jj)
      nf1=29
      do 25 i=1,7
      nf1=nf1+1
      read(nf1,1007) (b(i,j),j=1,itm)
   25 continue
c *** define the array of independent variables, y(i)
      do 35 j=1,itm
      do 30 i=1,7
      y(i)=dble(b(i,j))
   30 continue
c *** determine the spline-fit coefficients
      call akm_cspl(n,x,y,c)
c *** evaluate the splines at the input xx(i) = input reddening values
      call akm_eval(n,x,c,xin,yout,deriv)
      ys(j)=sngl(yout)
   35 continue
c *** write the interpolated BC values in the output file
      write(10,1007) (ys(j),j=1,itm)
   40 continue
   45 continue
   50 continue
      write(6,1010) fiout,xx
      close(unit=9,status='keep')
      close(unit=10,status='keep')
      close(unit=30,status='keep')
      close(unit=31,status='keep')
      close(unit=32,status='keep')
      close(unit=33,status='keep')
      close(unit=34,status='keep')
      close(unit=35,status='keep')
      close(unit=36,status='keep')
      stop
   60 stop ' problem with one of the input file assignments'
      end
      subroutine iofile(nunit,fstat,fnme,nch)
      integer*4 nunit,nch
      character*42 fnme
      character*2 fstat
 1000 format(' input file assigned to unit',i3,' does not exist',/,a42)
      if(fstat.eq.'in') go to 10
c *** the named file is apparently an output file
      open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='new')
      if(ierr.eq.0) go to 15
c *** if the named file already exists it is deleted and opened as a
c *** new file; i.e., the existing file will be overwritten
      open(unit=nunit,file=fnme(1:nch),status='old')
      close(unit=nunit,status='delete')
      open(unit=nunit,file=fnme(1:nch),status='new')
      go to 15
c *** the named file is an input file 
   10 open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='old')
      if(ierr.eq.0) go to 15
c *** the named input file apparently does not exist: execution terminated
      write(6,1000) nunit,fnme
      stop 'specified input file does not exist'
   15 return
      end
      SUBROUTINE AKM_CSPL (n,x,f,c)
c
c  DESCRIPTION
c  Subroutine akm_cspl is based on the method of interpolation described
c  by Hiroshi Akima (1970 Journal of the Association for Computing Machinery,
c  Vol. 17, pp. 580-602) and also by Carl de Boor (1978 Applied Mathematical
c  Sciences, Vol. 27, "A Practical Guide to Splines").
c
c  This routine computes the Akima spline interpolant with the "not-a-knot
c  end conditions which are useful when there is no information about the
c  derivatives at the endpoints. In this case P(1)=P(2) and P(n-2)=P(n-1);
c  in other words, x(2) and x(n-1) are not knots even though they define
c  the endpoints of a polynomial piece --- the spline must pass through
c  these two points. Thus, it is a requirement that f''' be continuous
c  across x(2) and x(n-1). 
c
c  DIMENSIONS
c  The internal work arrays dd, w, and s are restricted to 2000 elements 
c  by the parameter nmx; consequently the data arrays x and f are also
c  limited to 2000 elements. The spline coefficients are contained in
c  the array c, a 4x2000 2 dimensional array.
c
c  CALL PARAMETERS
c     n      - number of data pairs
c     x(n)   - array, independent variable
c     f(n)   - array, dependent variable
c     c(4,n) - array, spline coefficients
c
      implicit double precision (a-h, o-z)
      parameter (nmx = 3000)
      parameter (zero = 0.0d0, two = 2.0d0, three = 3.0d0)
      dimension x(n),f(n),c(4,n) 
      dimension dd(nmx),w(nmx),s(nmx)
c
      nm1 = n - 1
      nm2 = n - 2
      nm3 = n - 3
c
c  Create two additional points outside the region of the spline by fitting
c  a quadratic to the three adjacent data points. This is a special feature
c  of the Akima spline.
c
      call akm_ends (x(1),x(2),x(3),f(1),f(2),f(3),f0,fm1)
      call akm_ends (x(n),x(nm1),x(nm2),f(n),f(nm1),f(nm2),fnp1,fnp2)
c
c  Compute the divided differences
c
      ddm1 = (f0 - fm1)/(x(2) - x(1))
      dd0 = (f(1) - f0)/(x(3) - x(2))
      do i = 1, nm1
        ip1 = i + 1
        dd(i) = (f(ip1) - f(i))/(x(ip1) - x(i))
      end do
      dd(n) = (f(n) - fnp1)/(x(nm2) - x(nm1))
      ddnp1 = (fnp1 - fnp2)/(x(nm1) - x(n))
c
c  Compute the Akima weights
c
      w0 = abs (dd0 - ddm1)
      w(1) = abs (dd(1) - dd0)
      do i = 2, nm1
        im1 = i - 1
        w(i) = abs(dd(i) - dd(im1))
      end do
      w(n) = abs (dd(n) - dd(nm1))
      wnp1 = abs (ddnp1 - dd(n))
c
c  Compute Akima slopes at interior knots
c
      if (w(2).eq.zero.and.w0.eq.zero) then
        s(1) = 5.0d-1*(dd(1) + dd0)
      else
        s(1) = (w(2)*dd0 + w0*dd(1))/(w0 + w(2))
      end if
      do i = 2, nm1
        im1 = i - 1
        ip1 = i + 1
        if (w(ip1).eq.zero.and.w(im1).eq.zero) then
          s(i) = 5.0d-1*(dd(i) + dd(im1))
        else
          s(i) = (w(ip1)*dd(im1) + w(im1)*dd(i))/(w(im1) + w(ip1))
        end if
      end do
      if (wnp1.eq.zero.and.w(nm1).eq.zero) then
        s(n) = 5.0d-1*(dd(n) + dd(nm1))
      else
        s(n) = (wnp1*dd(nm1) + w(nm1)*dd(n))/(w(nm1) + wnp1)
      end if
c
c  Spline coefficients for all the polynomial pieces
c
      do i = 1, nm1
        ip1 = i + 1
        dx = x(ip1) - x(i)
        c(1,i) = f(i)
        c(2,i) = s(i)
        c(3,i) = (three*dd(i) - two*s(i) - s(ip1))/dx
        c(4,i) = (s(ip1) + s(i) - two*dd(i))/dx/dx
      end do
      return
      end
      SUBROUTINE AKM_ENDS(x1,x2,x3,f1,f2,f3,f00,f01)
c      
c  DESCRIPTION
c  Subroutine akm_ends is based on the method of interpolation described
c  by Hiroshi Akima (1970 Journal of the Association for Computing Machinery,
c  Vol. 17, pp. 580-602).
c
c  This routine is required by the routine AKM_CSPL. It sets up the two 
c  additional external points required by the Akima method of constructing
c  a spline.
c
c  CALL PARAMETERS
c  (x1,f1), (x2,f2) and (x3,f3) are the known data pairs at the ends of the
c  region of interpolation. f00 and f01 are the computed values of the
c  interpolating polynomial external to the region of interpolation.
c
      implicit double precision (a-h,o-z)
      g0 = f1
      df21 = f2 - f1
      df31 = f3 - f1
      dx21 = x2 - x1
      dx31 = x3 - x1
      dx32 = x3 - x2
      den = dx21*dx32*dx31
      g1 = (df21*dx31*dx31 - df31*dx21*dx21)/den
      g2 = (df31*dx21 - df21*dx31)/den
      f00 = g0 - g1*dx32 + g2*dx32*dx32
      f01 = g0 - g1*dx31 + g2*dx31*dx31
      return
      end
      SUBROUTINE AKM_EVAL (n,x,c,xp,fp,dfp)
c     
c  DESCRIPTION
c  This routine is used to evaluate the spline defined by the
c  routine AKM_CSPL and its derivative at an interpolating point.
c
c  CALL PARAMETERS
c     n      - number of data pairs
c     x(n)   - array, independent variable
c     c(4,n) - array, spline coefficients
c     xp     - interpolating point
c     fp     - value of the spline at xp
c     dfp    - first derivative of the spline at xp   
c     
      implicit double precision (a-h, o-z)
      dimension x(n), c(4,n)
      logical more
c
c  Statement function defines cubic spline interpolation
c
      csval(dx,a,b,e,d) = a +dx*(b + dx*(e + dx*d))
c
c  Statement function defines cubic spline derivative
c
      csder(dx,b,e,d) = b + dx*(2.0d0*e + dx*3.0d0*d)
c
c  Check direction of spline
c
      if (x(n).gt.x(1)) then
c
c  Check to see that x(1) < xp < x(n)
c
      if (xp.lt.x(1)) then
        write(*,'('' ***Test point is less than x(1)***'')')
        stop
      else if (xp.gt.x(n)) then
        write(*,'('' ***Test point is greater than x(n)***'')')
        stop
      end if
c
c  Find the polynomial piece containing the test point
c
      i = 2
      more = .true.
      do while (more)
        if (xp.lt.x(i).or.i.eq.n) then
          more = .false.
          nl = i - 1
        else 
          i = i + 1
        end if
      end do
      else
c
c  The spline is backwards
c  Check to see that x(n) < xp < x(1)
c
      if (xp.gt.x(1)) then
        write(*,'('' ***Test point is greater than x(1)***'')')
        stop
      else if (xp.lt.x(n)) then
        write(*,'('' ***Test point is less than x(n)***'')')
        stop
      end if
c
c  Find the polynomial piece containing the test point
c
      i = 2
      more = .true.
      do while (more)
        if (xp.gt.x(i).or.i.eq.n) then
          more = .false.
          nl = i - 1
        else 
          i = i + 1
        end if
      end do
      end if
c
c  Evaluate spline at the test point xp
c
      dx = xp - x(nl)
      fp = csval(dx,c(1,nl),c(2,nl),c(3,nl),c(4,nl))
c
c  Evaluate the derivative at the test point
c
      dfp = csder(dx,c(2,nl),c(3,nl),c(4,nl))
      return
      end        

C *** Sample code to obtain the absolute visual magnitude of the Sun
C     along with the solar B-V and V-I colors from the bolometric
C     corrections derived from MARCS model atmospheres.  The ubvri90
C     transformations for the B, V, and I bandpasses (nfil = 3) have
C     been assumed. The result of this computation is:
C              M_V = 4.818, B-V = 0.637, and V-I = 0.698.
C
C *** A second test calculation is carried out for [Fe/H] = -0.5 and all
C     four dependencies of [alpha/Fe] with [Fe/H].  The result of this
C     computation is:
C           [Fe/H]  log g  Teff [alpha/Fe]   BC_B      BC_V    BC_I
C     std:   -0.50    4.5   5750   0.20     -0.6966  -0.1040  0.5989
C     m04:                        -0.40     -0.7099  -0.1051  0.6024
C     p00:                         0.00     -0.7021  -0.1043  0.6004
C     p04:                        +0.40     -0.6901  -0.1036  0.5977
C     interpolate in previous 3:   0.20     -0.6966  -0.1039  0.5991
C
C     The interpolated BCs in the tables for [alpha/Fe] = -0.4, 0.0, and
C     +0.04 (given in the last line) clearly reproduce those given in the
C     first line (assuming the standard variation of [alpha/Fe] with [Fe/H])
C     very well.
C
C *** This code must be compiled and linked with the "bcutil.for" library
C     of interpolation subroutines, which require the input data files
C     "bc_std.data", "bc_m04.data", "bc_p00.data" and "bc_p04.data".  These
C     files are assigned internally to units 30, 31, 32, and 33, respectively.
C
      real*4 a(3),x(3),bcstd(5),bcm04(5),bcp00(5),bcp04(5)
      character*6 fil(5)
 1001 format(/,' TEST1: [Fe/H] =',f6.2,', log g =',f6.3,', Teff =',f6.0,
     1 /,24x,'M_V =',f6.3,',',3x,'B-V =',f7.3,',',2x,'V-I =',f7.3,/)
 1002 format(/,' TEST2: [Fe/H]',2x,'log g',3x,'Teff',1x,'[alpha/Fe]',2x,
     1 'BC_B',5x,'BC_V',5x,'BC_I',//,7x,f6.2,2x,f6.3,2x,f6.0,2x,f5.2,
     2 4x,f6.4,3x,f6.4,3x,f6.4,/,4(/,31x,f5.2,4x,f6.4,3x,f6.4,3x,f6.4))
c *** specify the solar values of [Fe/H], log g, and Teff.
      fe=0.0
      gv=4.44
      temp=5777.
      teff=alog10(temp)
c *** read the BC transformations and interpolate to [Fe/H] = fe = 0.0.
      call getbc_std(0,fe,gv,teff,ebv,bcstd,fil,nbc)
c *** interpolate to obtain the BC values for log g = gv = 4.434 and
c *** Teff = temp = 5777 K.
      call getbc_std(1,fe,gv,teff,ebv,bcstd,fil,nbc)
c *** calculate the absolute B, V, and I magnitudes.
      absb=4.75-bcstd(1)
      absv=4.75-bcstd(2)
      absi=4.75-bcstd(3)
c *** calculate the B-V and V-I colors.
      bmv=absb-absv
      vmi=absv-absi
c *** write the results to unit 6.
      write(6,1001) fe,gv,temp,absv,bmv,vmi
c
c *** now carry out the second exercise for [Fe/H] = -0.5, [alpha/Fe] = 0.2
      fe=-0.5
      afe=0.2
      gv=4.5
      temp=5750.
      teff=alog10(temp)
c *** reinterpolate the bc_std tables to the new value of [Fe/H] = fe = -0.5
      call getbc_std(-1,fe,gv,teff,ebv,bcstd,fil,nbc)
c *** now perform the gv and Teff interpolation
      call getbc_std(1,fe,gv,teff,ebv,bcstd,fil,nbc)
c *** read the BC transformation tables for [alpha/Fe] = -0.4, 0.0, and 0.4
c *** and interpolate these table to [Fe/H] = fe = -0.5
      call getbc_m04(0,fe,gv,teff,ebv,bcm04,fil,nbc)
      call getbc_p00(0,fe,gv,teff,ebv,bcp00,fil,nbc)
      call getbc_p04(0,fe,gv,teff,ebv,bcp04,fil,nbc)
c *** now interpolate in these 3 tables to obtain the BC values for the
c *** input values of log g = gv = 4.5 and log Teff = log(5750)
      call getbc_m04(1,fe,gv,teff,ebv,bcm04,fil,nbc)
      call getbc_p00(1,fe,gv,teff,ebv,bcp00,fil,nbc)
      call getbc_p04(1,fe,gv,teff,ebv,bcp04,fil,nbc)
c *** perform a 3-point Lagrangian interpolation of the latter to obtain
c *** the BC values at [alpha/Fe] = 0.2 (to compare with the result of
c *** interpolating in bc_std.data
      x(1)=-0.4
      x(2)=0.0
      x(3)=0.4
      call lgran3(x,a,afe)
      bcbx=a(1)*bcm04(1)+a(2)*bcp00(1)+a(3)*bcp04(1)
      bcvx=a(1)*bcm04(2)+a(2)*bcp00(2)+a(3)*bcp04(2)
      bcix=a(1)*bcm04(3)+a(2)*bcp00(3)+a(3)*bcp04(3)
c *** the results written to unit 6 should be identical to those given
c *** for this exercise in the commented section near the top of this code.
      write(6,1002) fe,gv,temp,afe,bcstd(1),bcstd(2),bcstd(3),x(1),
     1  (bcm04(i),i=1,3),x(2),(bcp00(i),i=1,3),x(3),(bcp04(i),i=1,3),
     2  afe,bcbx,bcvx,bcix
      stop
      end

C *** This program is used in conjunction with "selectbc.data" to retrieve
C     BC data for the photometric system and filter bandpasses of interest,
C     for all possible values of log g, and for a particular value of E(B-V)
C     (the choices being 0.00, 0.08, 0.14, 0.28, 0.44, and 0.56.)  These 
C     data, which were derived directly from MARCS models, may be compared
C     with the interpolated BC values to check that the interpolation code
C     accurately reproduces the MARCS results.  The user must select the
C     E(B-V) value from the aforementioned choices.
C
C *** The output of this program consists of 13 data files (one for each
C     log g value between -0.5 and +5.5) with names sphm05.data, sph00.data,
C     ..., ppl55.data.  If these files already exist, they will be over-
C     written.  The program chkbctable.for compares the results in these
C     data files with those obtained by interpolating in tables for E(B-V)
C     values from 0.00 to 0.72.     
C
C *** NOTE that "slash" as defined in the data statement (below) **MUST**
C     be defined to be a forward slash (i.e., "slash/'/'/" if this program
C     is executed on a linux or UNIX computer.  (A backslash is used in the
C     case of a WINDOWS operating system.)
C--------1---------2---------3---------4---------5---------6---------7--
      real*4 bc(800,13,5)
      integer*4 itmm(13),ndat(13),ngv(4)
      character*52 fnme,fnme0,fzero
      character*16 bcdata(800,13)
      character*12 filter(41),xfi(5),finme
      character*9 alpha(4),alnme
      character*8 system(7),xps(5),psnme
      character*6 gravity(13),fgrav
      character*5 ftype
      character*4 dtest
      character*3 ebmv(6),rednme
      character*1 slash,fundr
      data alpha/'alpha_std','alpha_p04','alpha_p00','alpha_m04'/,
     1  gravity/'sphm05','sph00 ','sph05 ','sph10 ','sph15 ','sph20 ',
     2  'sph25 ','sph30 ','sph35 ','ppl40 ','ppl45 ','ppl50 ','ppl55 '/,
     3  system/'2mass   ','hst_ab  ','hst_st  ','hst_vega','sdss    ',
     4  'ubvri12 ','ubvri90 '/,ebmv/'r00','r08','r14','r28','r44',
     5  'r56'/,dtest/'test'/,ftype/'.data'/,fundr/'_'/,ngv/13,12,12,12/,
     6  fzero/'                                                    '/,
C *** on linux/UNIX machines, slash must be defined as '/' instead of '\' 
     7  slash/'/'/
      data filter/'2mass_J     ','2mass_H     ','2mass_K     ',
     1  'acs_f435w   ','acs_f475w   ','acs_f555w   ','acs_f606w   ',
     2  'acs_f814w   ','wfc3_f218w  ','wfc3_f225w  ','wfc3_f275w  ',
     3  'wfc3_f336w  ','wfc3_f350lp ','wfc3_f390m  ','wfc3_f390w  ',
     4  'wfc3_f438w  ','wfc3_f475w  ','wfc3_f547m  ','wfc3_f555w  ',
     5  'wfc3_f606w  ','wfc3_f625w  ','wfc3_f775w  ','wfc3_f814w  ',
     6  'wfc3_f850lp ','wfc3ir_f098m','wfc3ir_f110w','wfc3ir_f125w',
     7  'wfc3ir_f140w','wfc3ir_f160w','sdss_u      ','sdss_g      ',
     8  'sdss_r      ','sdss_i      ','sdss_z      ','jc_U        ',
     9  'jc_B        ','jc_V        ','jc_R        ','jc_I        ', 
     *  'jc_UX       ','jc_BX       '/
 1000 format(' enter 1 for E(B-V) = 0.00, 2 for 0.08, 3 for 0.14',/,
     1  7x,'4 for E(B-V) = 0.28, 5 for 0.44, 6 for 0.56')
 1001 format(9x,f5.2)
 1002 format(' E(B-V) =',f5.2)
 1003 format(a16,5f8.4)
 1004 format(i3,' = number of data points')
 1005 format(' files sphm05.data, sph00.data, sph05.data, etc., have'
     1  1x,'been created',/,' for E(B-V) =',f5.2,' to test',5(/,10x,
     2  a8,': ',a12))
c *** the input file "selectbc.data" is assigned to unit 9
      fnme(1:13)='selectbc.data'
      call iofile(9,'in',fnme,13)
      read(9,*) ialf
      ng=ngv(ialf)
      ig=0
      if(ialf.eq.1) go to 5
      ig=1
c *** choose the E(B-V) value to be used in the comparison of MARCS and
c *** interpolated results
    5 write(6,1000)
      read(5,*) ired 
      rednme=ebmv(ired)
c *** the 13 output files (for different log g) are assigned to units 10-22 
      nf1=9
      do 10 i=1,ng
      nf1=nf1+1
      jig=i+ig
      fnme=fzero
      fgrav=gravity(jig)
      fnme(1:6)=fgrav(1:6)
      call str_trim(6,fnme,nch)
      fnme(nch+1:nch+5)=ftype(1:5)
      ntot=nch+5
      call iofile(nf1,'oo',fnme,ntot)
   10 continue
c *** the directory relevant to the desired variation of [alpha/Fe] with [Fe/H]
      alnme=alpha(ialf)
c *** the number of filters for which BC tables are requested is read (unit 9)
      read(9,*) numbc
c *** the main DO-loop is over the number of individual system/filter names
      do 35 k=1,numbc
c *** integers selecting the photometric system and filter are read (unit 9)
      read(9,*) isys,ifil
      psnme=system(isys)
      finme=filter(ifil)
      xps(k)=psnme
      xfi(k)=finme
c *** set up the directory portion of the input file name
      fnme=fzero
      fnme(1:9)=alnme(1:9)
      fnme(10:10)=slash(1:1)
      fnme(11:14)=dtest(1:4)
      fnme(15:15)=slash(1:1)
      fnme(16:18)=rednme(1:3)
      fnme(19:19)=slash(1:1)
      fnme(20:27)=psnme(1:8)
      call str_trim(52,fnme,nch)
      nch=nch+1
      fnme(nch:nch)=slash(1:1)
      nch0=nch
      fnme0=fnme
      nf2=24
      do 30 j=1,ng
      nf2=nf2+1
      jig=j+ig
      fgrav=gravity(jig)
      nch=nch0
      fnme=fnme0 
      fnme(nch+1:nch+6)=fgrav(1:6)
      nch=nch+6
      if(jig.eq.1) go to 15
      nch=nch-1
   15 fnme(nch+1:nch+1)=fundr(1:1)
      nch=nch+1
      fnme(nch+1:nch+12)=finme(1:12)
      call str_trim(52,fnme,nch)
      fnme(nch+1:nch+5)=ftype(1:5)
      nch=nch+5
      call iofile(nf2,'in',fnme,nch)
c *** copy over the header.data information into the unit 10-22 data files
      read(nf2,1001) redden
      do 20 i=1,800
      read(nf2,1003,end=25) bcdata(i,j),bc(i,j,k)
      n=i
   20 continue
      stop 'dimensions of bcdata(i) need to be increased'
   25 ndat(jig)=n
   30 continue
   35 continue
      nf1=9
      do 45 j=1,ng
      jig=j+ig
      nf1=nf1+1
      n=ndat(jig)
      write(nf1,1002) redden
      write(nf1,1004) n
      do 40 i=1,n
      write(nf1,1003) bcdata(i,j),(bc(i,j,k),k=1,numbc)
   40 continue
   45 continue
c *** all of the input and output files are kept on disk
      nf1=9
      nf2=24
      close(unit=9,status='keep')
      do 50 i=1,ng
      nf1=nf1+1
      nf2=nf2+1
      close(unit=nf1,status='keep')
      close(unit=nf2,status='keep')
   50 continue
      write(6,1005) redden,(xps(i),xfi(i),i=1,numbc)
      stop
      end
      subroutine str_trim(nl,str,nch)
      character*(*) str
      nch=nl
      do while (str(nch:nch).eq.' '.and.nch.gt.0)
        nch=nch-1
      end do
      return 
      end
      subroutine iofile(nunit,fstat,fnme,nch)
      integer*4 nunit,nch
      character*52 fnme
      character*2 fstat
 1000 format(' unit',i3,' input file does not exist',/,'name = ',a52)
      if(fstat.eq.'in') go to 10
c *** the named file is apparently an output file
      open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='new')
      if(ierr.eq.0) go to 15
c *** if the named file already exists it is deleted and opened as a
c *** new file; i.e., the existing file will be overwritten
      open(unit=nunit,file=fnme(1:nch),status='old')
      close(unit=nunit,status='delete')
      open(unit=nunit,file=fnme(1:nch),status='new')
      go to 15
c *** the named file is an input file 
   10 open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='old')
      if(ierr.eq.0) go to 15
c *** the named input file apparently does not exist: execution terminated
      write(6,1000) nunit,fnme
      stop ' specified input file does not exist'
   15 return
      end

C *** This program is used in conjunction with "selectbc.data" to set up the
C     BC tables for the photometric system and filter bandpasses of interest,
C     assuming E(B-V) = 0.0, 0.12, 0.24, 0.36, 0.48, 0.60, and 0.72.  The
C     resultant 7 tables are employed by "getbctable.for" to produce the BC
C     tables for the same filter bandpasses and any selected value of E(B-V)
C     in the range from 0.0 to 0.72.
C
C *** Regarding "selectbc.data":
C       1st line: integer is set to a value of 1, 2, 3, or 4 to specify
C                 which variation of [alpha/Fe] with [Fe/H] is to be assumed.
C       2nd line: integer is set to a value of 1, 2, ..., 5 to indicate the
C                 number of filter bandpasses for which BC values will be
C                 defined.  (The maximum value permitted is 5.)
C       next 1, 2, ..., 5 lines: the pairs of integers define the photometric
C                 system and filter for which BC values will be defined: the
C                 menu of possible values are given below the horizontal 
C                 line (e.g., 5 33 selects the sdss photometric system and
C                 the sdss i filter).
C
C *** The output of this program consists of seven data files named
C     inputbc_r00.data, inputbc_r12.data, ..., inputbc_r72.data.  If these
C     files already exist, they will be overwritten.     
C
C *** NOTE that "slash" as defined in the data statement (below) **MUST**
C     be defined to be a forward slash (i.e., "slash/'/'/" if this program
C     is executed on a linux or UNIX computer.  (A backslash is used in the
C     case of a WINDOWS operating system.)
C--------1---------2---------3---------4---------5---------6---------7--
      real*4 bc(31),teff(31),gv(13)
      integer*4 itmm(13)
      character*50 labtab
      character*42 fnme,fzero
      character*26 redden
      character*12 filter(41),xfi(5),finme
      character*11 hdr
      character*9 alpha(4),alnme
      character*8 system(7),xps(5),psnme,outtab
      character*5 ftype
      character*3 ebmv(7),rednme
      character*1 slash
      data alpha/'alpha_std','alpha_p04','alpha_p00','alpha_m04'/,ebmv/
     1  'r00','r12','r24','r36','r48','r60','r72'/,system/'2mass   ',
     2  'hst_ab  ','hst_st  ','hst_vega','sdss    ','ubvri12 ',
     3  'ubvri90 '/,fzero/'                                          '/,
C *** on linux/UNIX machines, slash must be defined as '/' instead of '\' 
     4  slash/'/'/,outtab/'inputbc_'/
      data filter/'2mass_J     ','2mass_H     ','2mass_K     ',
     1  'acs_f435w   ','acs_f475w   ','acs_f555w   ','acs_f606w   ',
     2  'acs_f814w   ','wfc3_f218w  ','wfc3_f225w  ','wfc3_f275w  ',
     3  'wfc3_f336w  ','wfc3_f350lp ','wfc3_f390m  ','wfc3_f390w  ',
     4  'wfc3_f438w  ','wfc3_f475w  ','wfc3_f547m  ','wfc3_f555w  ',
     5  'wfc3_f606w  ','wfc3_f625w  ','wfc3_f775w  ','wfc3_f814w  ',
     6  'wfc3_f850lp ','wfc3ir_f098m','wfc3ir_f110w','wfc3ir_f125w',
     7  'wfc3ir_f140w','wfc3ir_f160w','sdss_u      ','sdss_g      ',
     8  'sdss_r      ','sdss_i      ','sdss_z      ','jc_U        ',
     9  'jc_B        ','jc_V        ','jc_R        ','jc_I        ', 
     *  'jc_UX       ','jc_BX       '/,ftype/'.data'/,hdr/'header.data'/
 1000 format(i3,14x,i2,14x,i2,14x,i2,a26)
 1001 format(13f6.0)
 1002 format(15f4.1)
 1003 format(15i4)
 1004 format(i3,' Teffs',8x,i2,' log gs',7x,i2,' [Fe/H]s',6x,i2,a26)
 1005 format(a50,3x,a8)
 1006 format(10f8.4) 
 1007 format(' files inputbc_r00.data, inputbc_r12.data, etc., have',
     1  1x,'been created for',5(/,10x,a8,': ',a12))
c *** the input file "selectbc.data" is assigned to unit 9 
      fnme(1:13)='selectbc.data'
      call iofile(9,'in',fnme,13)
      read(9,*) ialf
      fnme=fzero
      fnme(1:8)=outtab(1:8)
      fnme(12:16)=ftype(1:5)
c *** the 7 output files (for different reddenings) are assigned to units 10-16 
      nf1=9
      do 10 i=1,7
      nf1=nf1+1
      rednme=ebmv(i)
      fnme(9:11)=rednme(1:3)
      call iofile(nf1,'oo',fnme,16)
   10 continue
c *** the directory relevant to the desired variation of [alpha/Fe] with [Fe/H]
      alnme=alpha(ialf)
c *** the number of filters for which BC tables are requested is read (unit 9)
      read(9,*) numbc
c *** the main DO-loop is over the number of individual system/filter names
      do 40 ll=1,numbc
c *** integers selecting the photometric system and filter are read (unit 9)
      read(9,*) isys,ifil
      psnme=system(isys)
      finme=filter(ifil)
      xps(ll)=psnme
      xfi(ll)=finme
c *** set up the directory portion of the header.data file names
      fnme=fzero
      fnme(1:9)=alnme(1:9)
      fnme(10:10)=slash(1:1)
      fnme(14:14)=slash(1:1)
c *** the header information is written to units 10-16 only when ll=1
      if(ll.ne.1) go to 20
      fnme(15:25)=hdr(1:11)
      nf1=9
      nf2=19
      do 15 j=1,7
      nf1=nf1+1
      nf2=nf2+1      
c *** modify, as appropriate, the reddening part of the header.data file name
      rednme=ebmv(j)
      fnme(11:13)=rednme(1:3)
c *** open the file header.data file for each E(B-V) value in turn 
      call iofile(nf2,'in',fnme,25)
c *** copy over the header.data information into the unit 10-16 data files
      read(nf2,1000) nt,ng,nfe,nbc,redden
      read(nf2,1001) (teff(i),i=1,nt)
      read(nf2,1002) (gv(i),i=1,ng)
      read(nf2,1003) (itmm(i),i=1,ng)
c *** nbc is redefined to be numbc
      nbc=numbc
      write(nf1,1004) nt,ng,nfe,nbc,redden
      write(nf1,1001) (teff(i),i=1,nt)
      write(nf1,1002) (gv(i),i=1,ng)
      write(nf1,1003) (itmm(i),i=1,ng)
   15 continue
c *** select the appropriate directories for the photometric system and filter
   20 call str_trim(8,psnme,nchp)
      fnme(15:14+nchp)=psnme(1:nchp)
      fnme(14+nchp+1:14+nchp+1)=slash
      call str_trim(12,finme,nch)
      fnme(15+nchp+1:15+nchp+nch)=finme(1:nch)
      fnme(16+nchp+nch:15+nchp+nch+5)=ftype(1:5)
      call str_trim(40,fnme,nch)
      nf1=9
      nf2=29
      do 35 j=1,7
      nf1=nf1+1
      nf2=nf2+1
      rednme=ebmv(j)
      fnme(11:13)=rednme(1:3)
c *** files containing the selected BC data are opened
      call iofile(nf2,'in',fnme,nch)
c *** the BC data are copied over to the output files assigned to units 13-16
      do 30 kk=1,nfe
      read(nf2,1005) labtab
      write(nf1,1005) labtab,psnme
      do 25 jj=1,ng
      itm=itmm(jj)
      read(nf2,1006) (bc(i),i=1,itm)
      write(nf1,1006) (bc(i),i=1,itm)
   25 continue
   30 continue
   35 continue
   40 continue
c *** all of the input and output files are kept on disk
      nf1=9
      nf2=19
      nf3=29
      close(unit=9,status='keep')
      do 65 i=1,7
      nf1=nf1+1
      nf2=nf2+1
      nf3=nf3+1
      close(unit=nf1,status='keep')
      close(unit=nf2,status='keep')
      close(unit=nf3,status='keep')
   65 continue
      write(6,1007) (xps(i),xfi(i),i=1,numbc)
      stop
      end
      subroutine str_trim(nl,str,nch)
      character*(*) str
      nch=nl
      do while (str(nch:nch).eq.' '.and.nch.gt.0)
        nch=nch-1
      end do
      return 
      end
      subroutine iofile(nunit,fstat,fnme,nch)
      integer*4 nunit,nch
      character*42 fnme
      character*2 fstat
 1000 format(' input file assigned to unit',i3,' does not exist',/,a42)
      if(fstat.eq.'in') go to 10
c *** the named file is apparently an output file
      open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='new')
      if(ierr.eq.0) go to 15
c *** if the named file already exists it is deleted and opened as a
c *** new file; i.e., the existing file will be overwritten
      open(unit=nunit,file=fnme(1:nch),status='old')
      close(unit=nunit,status='delete')
      open(unit=nunit,file=fnme(1:nch),status='new')
      go to 15
c *** the named file is an input file 
   10 open(unit=nunit,iostat=ierr,file=fnme(1:nch),status='old')
      if(ierr.eq.0) go to 15
c *** the named input file apparently does not exist: execution terminated
      write(6,1000) nunit,fnme
      stop 'specified input file does not exist'
   15 return
      end
